# kakao-partner-android-sdk

## 배포 

SDK 배포는 맥미니 서버에서 구동되고 있는 아래의 jenkins 서버(http://172.26.35.235/)에서 실행합니다.

> 위 서버 접속 불가 시 richard.jeon 에게 문의주세요.


SDK 배포는 아래의 두 jenkins job에서 일어나고 각 job 들은 각 프로젝트의 github 저장소와 매핑되어 있습니다.
각 job들은 각 저장소의 release/* 브랜치를 바라보고 가장 최신의 release/* 브랜치를 빌드하게 됩니다.

아래 결과물들이 배포됩니다.

1. SDK 모듈 (aar, source jar)
1. 문서
1. project zip


### kakao-open-android-sdk

오픈 SDK 모듈들을 배포하는 job입니다.

http://172.26.35.235/job/kakao-open-android-sdk/
git@github.daumkakao.com:kops/kakao-open-android-sdk-v2.git

### kakao-partner-android-sdk

파트너 SDK 배포 시에는 오픈 SDK 모듈들을 제외한 나머지 모듈들을 배포합니다.
이 제외할 모듈들은 `buildSrc/src/main/kotlin/Constants.kt` 에 정의되어 있으며 오픈 SDK에 모듈이 추가되거나 변경되면 **반드시 이 리스트도 업데이트 해주어야 합니다.**


http://172.26.35.235/job/kakao-partner-android-sdk/
git@github.daumkakao.com:kops/kakao-partner-android-sdk.git/


Github push 에 따른 자동 배포는 사용하고 있지 않으며 release/* 브랜치에 작업이 다 끝난 후 매뉴얼하게 job을 실행시키면 됩니다.


### 샘플앱 배포

#### 파트너 SDK 샘플앱

https://mobil.daumkakao.io/#/app/1440


https://mobil.daumkakao.io/#/app/1440/build/config


#### 오픈 SDK 샘플앱

https://mobil.daumkakao.io/#/app/1462

아래 링크에서 자동 배포 설정을 확인할 수 있습니다.

https://mobil.daumkakao.io/#/app/1462/build/config


### Version bumping

버전 범핑은 아래의 두군데 파일에서 해줘야 합니다.

- buildSrc/src/main/kotlin/Versions.kt
- open/buildSrc/src/main/kotlin/Versions.kt

release 브랜치 생성 후 버전 범핑을 바로 실행한 후 커밋 / 푸시를 하는게 좋습니다.

### 배포 관련 설정

`open/libraries.gradle` 파일에 `publishing` block에 배포 관련된 설정들이 명시되어 있습니다.


### 요약

정리해보자면, 배포 프로세스는 아래와 같습니다.

1. release 브랜치 생성
1. version bumping
1. release 브랜치 에서 테스트 중 bug fix 및 주석 등등 수정 후 커밋 / 푸 (optional)
1. 배포 준비가 완료된 시점에 `kakao-open-android-sdk` job 실행
1. `kakao-partner-android-sdk` job 실행
1. tag 생성 후 푸시
1. 샘플앱 빌드 및 배포

## Legacy

- legacy-sdk-deploy

http://172.26.35.235/job/legacy-sdk-deploy/build?delay=0sec

phase: alpha / sandbox / beta / real
name: android-rx-v2
download_url: http://devrepo.kakao.com:8088/nexus/content/groups/public/com/kakao/sdk/kakao-android-sdk-rx/2.0.0-beta01/kakao-android-sdk-rx-2.0.0-beta01.zip


URL 호출로 빌드를 유발시키기 위해서는 아래와 같은 url 을 호출하면 된다.

http://172.26.35.235/job/legacy-sdk-deploy/buildWithParameters?token=deploy&download_url=http://devrepo.kakao.com:8088/nexus/content/groups/public/com/kakao/sdk/kakao-android-sdk-rx/2.0.0-beta01/kakao-android-sdk-rx-2.0.0-beta01.zip&phase=alpha&filename=kakao-android-sdk-rx-2.0.0-beta01.zip&name=android-rx-v2

## Gradle tasks

보통 unit test 는 아래와 같은 tasks 를 통하여 실행합니다.

```shell
./gradlew test # testDebug 와 testRelease
./gradlew testDebug # 전체 모듈의 debug unit test 진행
./gradlew testRelease # 전체 모듈의 release unit test 진행. 릴리즈 전에 실행해야 하는 unit test

./gradlew partner-rx:testDebugUnitTest # partner-rx 모듈의 debug 빌드 unit test를 실행합니다.
./gradlew user-rx:testDebugUnitTest

./gradlew assembleRelease # 모든 모듈의 (샘플앱 포함) release 빌드된 바이너리 생성
./gradlew assembleDebug # 모든 모듈의 (샘플앱 포함) debug 빌드된 바이너리 생성
./gradlew partner-rx:assembleRelease # partner-rx 의 release 빌드된 바이너리 생성


./gradlew publishReleasePublicationToMavenRepository # 배포 task. 
./gradlew publishReleasePublicationToMavenRepository
./gradlew

./gradlew connectedAndroidTest # UI 테스트
./gradlew connectedDebugAndroidTest # UI 테스트
```

### PublishSdk task

`publishSdk` 는 SDK 에서 최종 배포를 담당하는 task 이고 아래와 같은 task 의존성 tree 를 가지고 있습니다.

각 모듈들 배포와 문서, project zip 배포를 실행하게 됩니다.

```kotlin
val publishSdk by tasks.registering(Task::class) {
    libraries.filter { it.name !in Publish.excludedLibraries }.forEach { project ->
        dependsOn(project.tasks["publish"])
    }
    dependsOn(tasks["publishDokkaPublicationToMavenRepository"])
    dependsOn(tasks["publishProjectPublicationToMavenRepository"])
}
```

- publishSdk
    - auth-common:publish
    - auth-rx:publish
    ...
    - publishDokkaPublicationToMavenRepository
    - publishProjectPublicationToMavenRepository
 
`open/build.gradle.kts`에 아래와 같이 문서와 project zip 배포 설정되어 있습니다.

```gradle
    publications {
        register("dokka", MavenPublication::class) {
            groupId = Publish.groupId
            artifactId = Publish.dokkaArtifactId
            version = SdkVersions.version
            artifact(zipDokka.get())
        }
        register("project", MavenPublication::class) {
            groupId = Publish.groupId
            artifactId = Publish.projectName
            version = SdkVersions.version
            artifact(zipProject.get())
        }
    }
```

### 모듈 관리


1. `kakao-partner-android-sdk` 프로젝트 내에서 File -> New -> New Module -> Android Library 선택
1. 모듈 이름 및 package name 선택 후 생성

각 모듈들은 아래와 같이 라이브러리 설정을 각 모듈의 `build.gradle` 해줘야 합니다.

```gradle

# library 플러그인 설정
plugins {
    id("com.android.library")
}

apply(from = "../open/libraries.gradle") # 공통 library 설정
apply(from = "../open/dependencies.gradle.kts") # 공통 의존성 설정
```

#### 오픈 SDK 모듈이라면?
1. 오픈 모듈 내로 모듈 이동
1. 오픈 SDK `settings.gradle.kts` 에 추가 / 파트너 SDK의 `settings.gradle.kts`에서 삭제
1. 오픈 모듈이라면 `buildSrc/src/kotlin/Constants.kt` 내의 `openLibraries` 리스트에 추가


#### 샘플앱 모듈

샘플앱 모듈이라면 `buildSrc/src/kotlin/Constants.kt` 와 `open/buildSrc/src/kotlin/Constants.kt` 에 샘플 모듈 리스트 또한 업데이트 해주어야 합니다.

```kotlin
object Dokka {
    val samples = listOf(
        "sample",
        "sample-common",
        "java-sample"
    )
    val includes = listOf("packages.md")
}
```


### Android plugins

아래와 같이 `android library` 혹은 `android application`으로 지정된 모듈들은 특정 tasks 들이 자동으로 생성됩니다.

```gradle
plugins {
    id("com.android.library")
    id("com.android.application")
}
```

- assemble
- assembleDebug
- assembleRelease
- connectedAndroidTest
- connectedDebugAndroidTest
- androidDependencies
...

module 별 빌드에서 android {} 블락이 생겨서 설정할 수 있게 됩니다.
`libraryVariants` 혹은 `applicationVariants`가 생성됩니다.

#### Publish plugin

`libraries.gradle`에 아래와 같이 publish 플러그인이 명시되어 있습니다.

```gradle
apply plugin: "maven-publish"
```

위와 같이 publish 플러그인을 명시하게 되면 아래와 같은 task 들이 자동 생성됩니다.

- publish
- publishReleasePublicationToMavenRepository

... 

Android SDK 에서는 debug 빌드는 배포 설정을 하지 않습니다.



```groovy
android {
    compileSdkVersion SdkVersions.compileSdkVersion // 무조건 최신 유지

    defaultConfig {
        minSdkVersion SdkVersions.minSdkVersion
        targetSdkVersion SdkVersions.targetSdkVersion // 무조건 최신 유지
        versionCode SdkVersions.versionCode
        versionName SdkVersions.version

        testInstrumentationRunner "androidx.test.ext.junit.runners.AndroidJunit4"

    }
    ...
```
### Test

안드로이드 unit test 는 junit 5 test 와 Robolectric test 두가지로 나뉩니다.
Robolectric test 는 
기본적으로 최대한 많은 테스트를 junit 5 test 로 실행하는 것을 목표로 합니다.
Robolectric test 는 jvm 위에 android simulation 환경을 로딩하기 때문에 일반적인 junit test 보다 느리게 됩니다.

아래의 경우에 Robolectric test 를 사용합니다.

- Bundle
- Uri
- PackageManager
- Intent

아래의 안드로이드 클래스들을 사용하는 경우에는 UI test를 사용하는 것을 추천합니다.

- Activity
- startActivity 등등

#### Robolectric test 의 예제
`open/network-rx/src/test/java/AppKeyInterceptorTest.kt`

Robolectric test 는 junit 5 가 아닌 junit 4를 사용하기 때문에 junit 4 import 문을 사용하여아 함.

```kotlin
import org.junit.Before
import org.junit.Test
```
